;;; CADALYST 07/07  Tip 2221: CPL.lsp	Copy Objects to Layer	(c) 2007 Theodorus Winata


;;; This program copies the selected entities
;;; to the layer you select from the layer list
;;; or matches layer from object you pick
;;; By Theodorus Winata
(defun C:CPL (/ APP BP C CHG CME D DCL_ID ELAST LALIST
	      LEN LNAME M:ERR NEXT NEWLAY NUM OBJ TP)
  (setq M:ERR *ERROR* *ERROR* *MERR*
	CME (getvar "CMDECHO")   );;setq
  (setvar "CMDECHO" 0) ;;; Make a list of defined layers
  (setq LNAME (cdr (assoc 2 (tblnext "layer" T)))
	LALIST (list LNAME)   );;setq
  (while (/= LNAME nil)
    (setq LNAME (cdr (assoc 2 (tblnext "layer"))))
    (if (/= LNAME nil)
      (progn
	(setq APP (list LNAME)
	      LALIST (append LALIST APP)
	      );;setq
	);;progn
      );;if
    );;while
  (tblnext "layer" "rewind")
  (setq LALIST (acad_strlsort LALIST))
  ;;; The default new layer is the current layer
  (setq NEWLAY (getvar "CLAYER"))
  ;;; Starting the dialog box, which only will be unloaded if the
  ;;; DONE_DIALOG attribute are less than 2
  (setq NEXT 3)
  (while (< 2 NEXT)
    (setq DCL_ID (load_dialog "CPL.dcl"))
    (if (not  (new_dialog "copy" DCL_ID))
      (exit))
    ;;; Presetting the dialog tiles
    (start_list "llist")
    (mapcar 'add_list LALIST)
    (end_list)
    (set_tile "layer" NEWLAY)
    ;;; Defining the dialog tile functions
    (action_tile "llist" "(setq NEWLAY (nth (atoi $value) LALIST))(set_tile \"layer\" NEWLAY)")
    (action_tile "layer" "(setq NEWLAY $value)")
    (action_tile "copy" "(done_dialog 3)")
    (action_tile "accept" "(done_dialog 1)")
    (setq NEXT (start_dialog))
    (cond
      ((= NEXT 3)
       (setq NEWLAY (cdr (assoc 8 (entget (car (entsel "Match layer from object: "))))))
       );;NEXT 3
      ;;; This is the lines which accomplish the function
      ((= NEXT 1)
       (prompt "\nCOPY")
       (setq CHG (ssget)
	     BP (getpoint "\nSpecify base point or displacement: ")
	     TP (getpoint BP "\nSpecify second point of displacement: ")
	     NUM 0
	     LEN (sslength CHG)
	     );;setq
       (repeat LEN
	 (setq C (ssname CHG NUM)
	       D (entget C)
	       OBJ (cdr (assoc -1 D))
	       );;setq
	 (command "copy" OBJ "" BP TP)
	 (setq ELAST (entlast))
	 (command "change" ELAST "" "properties" "layer" NEWLAY "")
	 (setq NUM (+ 1 NUM))
	 );;repeat
       );;NEXT 1
      );;cond
    );;while
  (unload_dialog DCL_ID)
  (command "layer" "set" "0" "")
  (setvar "CMDECHO" CME)
  (setq *ERROR* M:ERR M:ERR nil)
  (princ)
  );;C:CPL